// This class represents a tree of integers
public class IntTree {
    private IntTreeNode overallRoot;

    public IntTree(int[] values) {
        
    }

    // Constructs the tree shown
    public IntTree() {
        overallRoot = new IntTreeNode(6);
        overallRoot.left = new IntTreeNode(3);
        overallRoot.right = new IntTreeNode(2);
        overallRoot.left.left = new IntTreeNode(1);
        overallRoot.left.right = new IntTreeNode(4);
        overallRoot.right.left = new IntTreeNode(6);
        overallRoot.right.right = new IntTreeNode(4);
    }

    // Class that represents a single node in the tree
    private static class IntTreeNode {
        public int data; // data stored at this node
        public IntTreeNode left; // reference to left subtree
        public IntTreeNode right; // reference to right subtree

        // Constructs a leaf node with the given data.
        public IntTreeNode(int data) {
            this(data, null, null);
        }

        // Constructs a leaf or branch node with the given data and links.
        public IntTreeNode(int data, IntTreeNode left, IntTreeNode right) {
            this.data = data;
            this.left = left;
            this.right = right;
        }
    }
}
